// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#include <fennec/platform/interface/window.h>
#include <fennec/renderers/interface/gfxsurface.h>
#include <fennec/platform/interface/display_server.h>

namespace fennec
{

window::window(display_server* server, const config& conf, window* parent)
	: server(server), parent(parent)
	, root([&]() -> auto {
		window* rt = parent ? parent : this;
		while (rt->get_parent() != nullptr and rt->is_popup()) {
			rt = root->get_parent();
		}
		return rt;
	}())
	, cfg(conf), state() {
	state.mode = conf.mode;

	// if parent is null, root will point to this
	assertf(root != nullptr, "Failed to find appropriate top-level window.");
}

window::~window() {

}

void window::begin_frame() {
	gfx_surface->make_current();
}

void window::end_frame() {
	gfx_surface->swap();
}

}
